=== modified file 'branchview/linegraph.py'
--- branchview/linegraph.py	2008-03-27 16:27:29 +0000
+++ branchview/linegraph.py	2008-04-11 20:34:06 +0000
@@ -42,6 +42,9 @@
     curved, kinked, etc.) and to pick the actual colours for each index.
     """
     
+    if type(start_revs) != list:
+        start_revs = [start_revs]
+        
     graph = repository.get_graph()
     graph_parents = {}
     graph_children = {}

=== modified file 'dialog.py'
--- dialog.py	2008-04-10 19:39:21 +0000
+++ dialog.py	2008-04-11 20:34:06 +0000
@@ -54,54 +54,3 @@
 def question_dialog(primary, secondary):
     """ Display a dialog with the given question. """
     return _message_dialog(gtk.MESSAGE_QUESTION, primary, secondary, gtk.BUTTONS_YES_NO)
-
-def _chooserevison_dialog(history):
-    """ Display a dialog with list of revisions. """
-    dialog = gtk.Dialog()
-    hbox = gtk.HBox()
-    dialog.vbox.pack_start(hbox)
-    dialog.vbox.set_spacing(2)
-    
-    img = gtk.Image()
-    img.set_from_stock(gtk.STOCK_DIALOG_QUESTION,gtk.ICON_SIZE_DIALOG)
-    hbox.pack_start(img)
-    
-    hbox.set_spacing(10)
-    vbox = gtk.VBox()
-    vbox.set_spacing(10)
-    hbox.pack_start(vbox)
-    
-    lbl = gtk.Label("<b>Select a revision</b>")
-    lbl.set_use_markup(True)
-    lbl.set_alignment(0,0)
-    vbox.pack_start(lbl)
-    
-    revisioncombo = gtk.ComboBox()
-    model = gtk.ListStore(str,str)
-    revisioncombo.set_model(model)
-    
-    for item in history:
-        numver = ""
-        for ver in item[3]: # item 3 contains a list with revision number and subnumbers
-            numver = numver + str(ver) + "." # here we make a 'readable' version number (IE: 30.1.5)
-        numver = numver[0:-1]
-        model.append((item[1],numver))
-    
-    cell = gtk.CellRendererText()
-    revisioncombo.pack_start(cell, True)
-    revisioncombo.add_attribute(cell, 'text', 1)
-    
-    vbox.pack_start(revisioncombo)
-    
-    dialog.vbox.show_all()
-    dialog.add_buttons(gtk.STOCK_CANCEL,gtk.RESPONSE_REJECT,gtk.STOCK_OK,gtk.RESPONSE_OK)
-    returncode = dialog.run()
-    active_iter = revisioncombo.get_active_iter()
-    if active_iter != None:
-        val = model.get_value(active_iter,0) # get selected revision id from model
-    else:
-        val = ''
-        
-    dialog.destroy()
-    
-    return (returncode, val) #return dialog return code and selected revision ID

=== modified file 'viz/branchwin.py'
--- viz/branchwin.py	2008-04-10 19:39:21 +0000
+++ viz/branchwin.py	2008-04-11 20:34:06 +0000
@@ -18,11 +18,9 @@
 from bzrlib.plugins.gtk.tags import AddTagDialog
 from bzrlib.plugins.gtk.preferences import PreferencesWindow
 from bzrlib.plugins.gtk.branchview import TreeView, treemodel
-from bzrlib.plugins.gtk.dialog import _chooserevison_dialog
 from bzrlib.revision import Revision, NULL_REVISION
 from bzrlib.config import BranchConfig
 from bzrlib.config import GlobalConfig
-from bzrlib.tsort import merge_sort
 
 class BranchWindow(Window):
     """Branch window.
@@ -388,40 +386,17 @@
         """Callback for revision 'compare with' menu. Will show a small
             dialog with branch revisions to compare with selected revision in TreeView"""
         
-        start_revs = (self.branch.last_revision(),) #create touple with only last revision
-        graph = self.branch.repository.get_graph()
-
-        graph_parents = {} # this code is copied from "branchview/linegraph.linegraph()" and is the
-                           # only way I found to generate a list of revision numbers...
-                           
-        for (revid, parent_revids) in graph.iter_ancestry(start_revs):
-            graph_parents[revid] = parent_revids
-
-        graph_parents["top:"] = start_revs
-
-        if len(graph_parents)>0:
-            merge_sorted_revisions = merge_sort(
-                graph_parents,
-                "top:",
-                generate_revno=True)
-        else:
-            merge_sorted_revisions = ()
-
-        response, revid2 = _chooserevison_dialog(merge_sorted_revisions) # show dialog passing revisions
-
-        if response == gtk.RESPONSE_OK and revid2 != '':
+        from bzrlib.plugins.gtk.revbrowser import RevisionBrowser
+        
+        rb = RevisionBrowser(self.branch,self)
+        ret = rb.run()
+        
+        if ret == gtk.RESPONSE_OK:          
             (path, focus) = self.treeview.treeview.get_cursor()
             revid = self.treeview.model[path][treemodel.REVID]
-
-            from bzrlib.plugins.gtk.diff import DiffWindow
-            window = DiffWindow(parent=self)
-            rev_tree = self.branch.repository.revision_tree(revid)
-            parent_tree = self.branch.repository.revision_tree(revid2)
-            window.set_diff(revid, rev_tree, parent_tree)
-            window.show()
-
-        elif response == gtk.RESPONSE_OK and revid2 == '':
-            error_dialog("Bad revision","You must select a revision")
+            self.show_diff(revid, rb.selected_revid)
+            
+        rb.destroy()
             
     def _set_revision_cb(self, w, revision_id):
         self.treeview.set_revision_id(revision_id)

